#include <opencv2/objdetect/objdetect.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>

#include <iostream>
#include <stdio.h>

using namespace std;
using namespace cv;

void detectAndDisplay(Mat frame, CascadeClassifier& faceCascade ) {
    std::vector<Rect> faces;
    Mat frameGray;
    cvtColor(frame, frameGray, COLOR_BGR2GRAY);
    faceCascade.detectMultiScale(frameGray, faces, 1.1, 2, 0 | CASCADE_SCALE_IMAGE, Size(30, 30));

	for(int i = 0;i<faces.size();++i) {
		rectangle(frame, faces[i], Scalar(0, 255, 0), 2, 8, 0);
	}

	imshow("Video", frame);
}

int main(void)
{
	CascadeClassifier faceCascade;
    VideoCapture cam(0);

    if (!cam.isOpened())
        return -1;

    if (!faceCascade.load("haarcascade_frontalface_alt2.xml")) {
        return (-1);
    };

    while(true) {
    	Mat frame;
        cam >> frame;
		detectAndDisplay(frame,faceCascade);
        if (27 == char(waitKey(10))) {
            break;
        }
    }

    return 0;
}

